'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _makePlural = require('make-plural');

var _makePlural2 = _interopRequireDefault(_makePlural);

var _pluralCategories = require('make-plural/umd/pluralCategories');

var _pluralCategories2 = _interopRequireDefault(_pluralCategories);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// does not check for duplicate subtags
var isStructurallyValidLanguageTag = function isStructurallyValidLanguageTag(locale) {
    return locale.split('-').every(function (subtag) {
        return (/[a-z0-9]+/i.test(subtag)
        );
    });
};

var canonicalizeLocaleList = function canonicalizeLocaleList(locales) {
    if (!locales) return [];
    if (!Array.isArray(locales)) locales = [locales];
    return locales.map(function (tag) {
        // Requiring tag to be a String or Object means that the Number value
        // NaN will not be interpreted as the language tag "nan", which stands
        // for Min Nan Chinese.
        switch (typeof tag === 'undefined' ? 'undefined' : _typeof(tag)) {
            case 'string':
                break;
            case 'object':
                tag = tag.toString();break;
            default:
                throw new TypeError('Locales should be strings, ' + JSON.stringify(tag) + " isn't.");
        }
        if (!isStructurallyValidLanguageTag(tag)) {
            throw new RangeError('The locale ' + JSON.stringify(tag) + ' is not a structurally valid BCP 47 language tag.');
        }
        return tag;
    }).reduce(function (seen, tag) {
        if (seen.indexOf(tag) < 0) seen.push(tag);
        return seen;
    }, []);
};

var defaultLocale = function defaultLocale() {
    return typeof navigator !== 'undefined' && navigator && (navigator.userLanguage || navigator.language) || 'en-US';
};

var findLocale = function findLocale(locale) {
    do {
        if (_makePlural2.default[locale]) return locale;
        locale = locale.replace(/-?[^-]*$/, '');
    } while (locale);
    return null;
};

var resolveLocale = function resolveLocale(locales) {
    var canonicalLocales = canonicalizeLocaleList(locales);
    for (var i = 0; i < canonicalLocales.length; ++i) {
        var lc = findLocale(canonicalLocales[i]);
        if (lc) return lc;
    }
    return findLocale(defaultLocale());
};

var getType = function getType(type) {
    if (!type) return 'cardinal';
    if (type === 'cardinal' || type === 'ordinal') return type;
    throw new RangeError('Not a valid plural type: ' + JSON.stringify(type));
};

var handleLocaleMatcher = function handleLocaleMatcher(localeMatcher) {
    if (localeMatcher && localeMatcher !== 'best fit' && typeof console !== 'undefined') {
        console.warn('intl-polyfill only supports `best fit` localeMatcher');
    }
};

var PluralRules = function () {
    _createClass(PluralRules, null, [{
        key: 'supportedLocalesOf',
        value: function supportedLocalesOf(locales) {
            var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
                localeMatcher = _ref.localeMatcher;

            handleLocaleMatcher(localeMatcher);
            return canonicalizeLocaleList(locales).filter(findLocale);
        }
    }]);

    function PluralRules(locales) {
        var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            localeMatcher = _ref2.localeMatcher,
            type = _ref2.type;

        _classCallCheck(this, PluralRules);

        handleLocaleMatcher(localeMatcher);
        this.type = getType(type);
        this.locale = resolveLocale(locales);
    }

    _createClass(PluralRules, [{
        key: 'resolvedOptions',
        value: function resolvedOptions() {
            return {
                locale: this.locale,
                pluralCategory: _pluralCategories2.default[this.locale][this.type],
                type: this.type
            };
        }
    }, {
        key: 'select',
        value: function select(number) {
            return _makePlural2.default[this.locale](number, this.type === 'ordinal');
        }
    }]);

    return PluralRules;
}();

exports.default = PluralRules;